#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sched.h>

extern char **environ;
static int Q, T;

static int args_parse(int argc, char *argv[])
{
  int v;

  Q =  300000;
  T = 1000000;
  while ((v = getopt(argc, argv, "q:t:")) != -1) {
    switch (v) {
      case 'q':
        Q = atoi(optarg);
        break;
      case 't':
        T = atoi(optarg);
        break;
      default:
        fprintf(stderr, "Exiting because of illegal option!\n");
        
        exit(-1);
    }
  }
  if (argc - optind < 1) {
    printf("Usage: %s [options] <command>\n", argv[0]);

    return -1;
  }

  return optind;
}

int main(int argc, char *argv[])
{
  int i;
  struct sched_param sp;
  int res, cmd_index;
  char **my_args;

  cmd_index = args_parse(argc, argv);
  if (cmd_index < 0) {
    return -1;
  }

  sp.sched_priority = 0;
  sp.sched_ss_init_budget.tv_nsec = Q * 1000;
  sp.sched_ss_init_budget.tv_sec = 0;
  sp.sched_ss_repl_period.tv_nsec = T * 1000 ;
  sp.sched_ss_repl_period.tv_sec = 0 ;
  res = sched_setscheduler(getpid(), SCHED_CBS, &sp);
  if (res < 0) {
    perror("Error in setscheduler!");
    exit(-1);
  }

  my_args = malloc(sizeof(char *) * (argc - cmd_index));
  for (i = cmd_index ; i < argc; i++) {
    printf("Setting argv[%d] = %s\n", i - cmd_index, argv[i]);
    my_args[i - cmd_index] = argv[i];
  }
  my_args[argc - cmd_index] = NULL;

  execve(argv[cmd_index], my_args, environ);

  perror("ExecVE Failed:");

  return -1;
}

